/*
Scrivere un programma per la gestione degli iscritti a un miniclub e delle loro attivit.
Gli iscritti sono caratterizzati da: nominativo, codice identificativo, fascia et (0=3-5 anni, 1=6-7 anni, 2=8-10 anni).
Le attivit sono caratterizzate da: codice identificativo iscritto, codice animatore,  tipo di attivit (0..3). 
Gli iscritti sono inseriti in un vettore di 3 liste,  una per ogni fascia di et. 
Le attivit sono inserite in una tabella allocata dinamicamente avente 4 righe, una  per ogni tipo di attivit.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento  nel vettore di liste di un nuovo iscritto; 
2.	Eliminazione di un iscritto dopo la sua visualizzazione ( chiedere codice identificativo e fascia d'et);
3.	Inserimento di una nuova attivit;
4.	Visualizzazione delle attivit degli iscritti fatte con un certo animatore (chiedere il codice dell'animatore);
5.	Salvataggio su file delle attivit;

All'avvio del programma inizializzare la tabella delle attivit leggendo da file le attivit precedentemente salvate.

*/

#include<stdio.h>
#include<stdlib.h>

struct iscritto {
       char nominativo [30];
       int codice;
       int eta;
       };
       
   
struct atomo {
       struct iscritto dato;
       struct atomo *next;
       };
       
       
struct attivita {
       int codice;
       int animatore;
       int tipo;
       };
       

void ins_iscritto (struct atomo *L[3]);
void elimina (struct atomo *L[3]);
void inizializza_tabella (struct attivita *T[4], int *N);
void leggi_attivita (struct attivita *d);
void inserisci_attivita (struct attivita **T, int *N, struct attivita d);
void visualizza_attivita (struct attivita *T[4], int *N);
void salva_file (struct attivita *T[4], int *N);

main ()
{
     struct atomo *L[3], *a;
     struct iscritto s;
     struct attivita d, *T[4];
     int N[4], i, scelta;

    
     /* Inizializzazione */
     for (i=0; i<4 ;i++)
     {
         T[i]=NULL;
         N[i]=0;
         }
     
     
     for (i=0; i<3 ;i++)
     L[i]=NULL;
   
     inizializza_tabella (T,N);
      
      
     do {
         printf ("\n Scegli tra: \n \n");
         printf ("1) Inserisci un nuovo iscritto \n");
         printf ("2) Elimina iscritto \n");
         printf ("3) Inserisci una nuova attivita' \n");
         printf ("4) Visualizza attivita' \n");
         printf ("5) Salva attivita' su file \n");
         printf ("0) Fine esecuzione \n");
         scanf ("%d", &scelta);
         switch (scelta)
         {
                case 1:
                     ins_iscritto (L);
                     break;
                case 2:
                     elimina (L);
                     break;
                case 3:
                     leggi_attivita (&d);
                     i=d.tipo;
                     inserisci_attivita (&T[i], &N[i], d);
                     break;
                case 4:
                     visualizza_attivita (T,N);
                     break;
                case 5:
                     salva_file (T,N);
                     break;
                     default:;
                     }
                     } while (scelta!=0);
                     
    /* liberazione della memoria */                 
     for (i=0; i<4; i++)
        T[i]==NULL;
     
     
     for (i=0; i<3 ;i++)
       while (L[i]=NULL)
          {
           a=L[i];
           L[i]=a->next;
           free (a);
          } 
     
}
  
      
void ins_iscritto (struct atomo *L[3])
{
     struct iscritto s;
     struct atomo *aux;
     int i;
     aux=malloc(sizeof (struct atomo));
     if(aux==NULL)
     return;
     
     printf ("Nominativo:\n ");
     scanf ("%s", s.nominativo);
     printf ("Codice identificativo: \n");
     scanf ("%d",&s.codice);
     printf ("Fascia eta'(0,1,2):\n");
     scanf ("%d", &s.eta);
    
     i=s.eta;
     aux->dato=s;
     aux->next=L[i];
     L[i]=aux;
}
     
void elimina (struct atomo *L[3])
{
     struct atomo *l1, *l2;
     int i;
     int codice, eta;
     
     printf ("Fascia eta'(0,1,2):\n");
     scanf("%d",&eta);
     
     if(L[eta]==NULL) /* lista vuota */
       {printf("Nessun elemento per questa fascia d'eta'\n");
        return;
       } 
     
     printf ("codice identificativo: \n");
     scanf ("%d", &codice);
     
     
     if (L[eta]->dato.codice==codice) /*trovato in testa */
       {  /* visualizzazione */
          printf ("nominativo:%s", L[eta]->dato.nominativo);
          /* eliminazione dalla testa*/
          l1=L[eta];
          L[eta]=l1->next;
          free(l1);
          return;
       }
      /* ricerca ed eliminazione in posizione successiva alla prima*/ 
      l2=L[eta];
      l1=l2->next;
      while(l1!=NULL)
         if (l1->dato.codice==codice) /* trovato */
            {  /* visualizzazione */
               printf ("nominativo:%s", l1->dato.nominativo);
               
               /* eliminazione*/
               l2->next=l1->next;
               free(l1);
               return;
            }
          else { l2=l2->next;
                 l1=l1->next;
               }
     /* se si arriva in questo punto l'elemento non e' stato trovato */
     printf("Non trovato\n");
}
           
               
 
         
 void leggi_attivita (struct attivita *d)
 {
      printf ("Codice identificativo iscritto: \n");
      scanf ("%d", &d->codice);
      printf ("codice animatore: \n");
      scanf ("%d", &d->animatore);
      printf ("tipo di attivita' (0..3): \n");
      scanf ("%d", &d->tipo);
      }
      
void inserisci_attivita (struct attivita **T, int *N, struct attivita d)
{
     struct attivita *a;
     a=realloc (*T, (*N+1)*sizeof (struct attivita));
     if (a==NULL)
     return;
     *T=a;
     (*T)[*N]=d;
     (*N)++;
     }
     
void visualizza_attivita (struct attivita *T[4], int *N)
{
     int i,j;
     int animatore;
     printf ("inserisci codice animatore: \n");
     scanf ("%d", &animatore);
     
     for(i=0;i<4;i++)
      for (j=0; j<N[i]; j++)
        if(T[i][j].animatore==animatore)
         {
           printf ("codice identificativo iscritto: %d\n", T[i][j].codice);
           printf ("tipo di attivita'(0..3): %d\n\n", T[i][j].tipo);
         }
}
   
     
void salva_file (struct attivita *T[4], int *N)
{
     int i;
     FILE *pf;
     pf=fopen("attivita.txt","w");
     
     if(pf!=NULL)
     {
                 for (i=0; i<4; i++)
                 fwrite (T[i], sizeof (struct attivita), N[i], pf);
                 fclose (pf);
                 }
                 
                 else 
                 printf ("\n errore in scrittura!! \n\n");
                 }
                 

void inizializza_tabella (struct attivita *T[4], int *N)
    {
         int tipo;
         struct attivita d, *p;
         FILE *pf;
         pf=fopen ("attivita.txt", "r");
         
         if (pf!=NULL)
         { while (fread(&d,sizeof (struct attivita),1,pf))
            {
               tipo=d.tipo;
               inserisci_attivita(&T[tipo],&N[tipo],d);
            }      
           fclose (pf);
         }
         
    }
     
     
                         
     
     
     
         

     
     

     
     
     
