/*
Scrivere un programma per la gestione degli iscritti a un campo estivo per ragazzi e delle loro attivit.
Gli iscritti sono caratterizzati da: 
nominativo, codice identificativo, codice istituto di provenienza, fascia et (0=6-7 anni, 1=8-10 anni, 2=11-14 anni, 3=15-16 anni).
Le attivit sono caratterizzate da: codice identificativo iscritto, codice animatore,  tipo di attivit (0..3). 
Gli iscritti sono inseriti in un vettore di 4 liste,  una per ogni fascia di et. 
Le attivit sono inserite in una tabella allocata dinamicamente avente 4 righe, una  per ogni tipo di attivit.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento  nel vettore di liste di un nuovo iscritto; 
2.	Visualizzazione per tutte le fasce d'et degli iscritti provenienti da un certo istituto    ( chiedere codice dell'istituto);
3.	Inserimento ordinato rispetto al codice identificativo di una nuova attivit;
4.	Visualizzazione delle attivit di un certo tipo (chiedere il tipo di attivit);
5.	Salvataggio su file delle attivit;

All'avvio del programma inizializzare la tabella delle attivit leggendo da file le attivit precedentemente salvate.

Liberare la memoria allocata dinamicamente.
 
*/



#include <stdio.h>
#include <stdlib.h>


struct iscritto {
        char nominativo[40];
        int  codiceidentificativo, codiceprovenienza, fasciaeta;
        };

struct attivita{
        int codiceiscritto, codiceanimatore, tipoattivita;
        } ; 
        
struct atomo {
       struct iscritto dato;
       struct atomo *next;
       };
       
void leggi_iscritto(struct iscritto *s);
void ins_iscritto(struct atomo **TL, struct iscritto s);
void vis_iscritto(struct atomo *TL[4]);
void leggi_attivita(struct  attivita *a);
void ins_ordinato(struct attivita *TP[4],int *N, struct attivita a);
void vis_attivita(struct attivita *TP[4], int *N);
void salva(struct attivita *TP[4], int *N);
void libera_liste(struct atomo **TL);
void iniz_tab(struct attivita *TP[4], int *N);

main(){
       struct atomo *LC[4];
       struct attivita *TP[4];
       struct attivita a;
       struct iscritto s;
       int N[4],opz,i;
       
       for(i=0;i<4;i++)
       {
        TP[i]=NULL;
        N[i]=0;
       }
       for(i=0;i<4;i++)
         LC[i]=NULL;
          
       iniz_tab(TP,N);
          
       do{
                printf("\nPROGRAMMA PER LA GESTIONE DEGLI ISCRITTI A UN CAMPO ESTIVO PER RAGAZZI E DELLE LORO ATTIVITA'\n");
                printf("\nScegli fra:\n");
                printf("1)Inserimento nuovo iscritto:\n");
                printf("2)Visualizza iscritto:\n");
                printf("3)Inserimento nuova attivita':\n");
                printf("4)Visualizza attivita':\n");
                printf("5)salvataggio su file delle attivita':\n");
                printf("0) Fine\n\n");
          scanf("%d",&opz);
          switch(opz){
                     
                      case 1: leggi_iscritto(&s);
                              ins_iscritto(&LC[s.fasciaeta],s);
                              break;
                      case 2: vis_iscritto(LC);
                              break;
                      case 3: leggi_attivita(&a);
                              ins_ordinato(TP,N,a);
                              break;
                      case 4: vis_attivita(TP,N);
                              break;
                     case 5: salva(TP,N);
                              break;
                     default:;
                     }
          }while(opz!=0);
           for(i=0;i<4;i++)
              libera_liste(&LC[i]);
           for(i=0;i<4;i++)
              free(TP[i]);
      }

void leggi_iscritto(struct iscritto *s) 
{    
     printf("Inserisci nominativo: ");
     scanf("%s", &s->nominativo);
     printf("Inserisci il codice identificativo: ");
     scanf("%d",&s->codiceidentificativo);
     printf("Inserisci il codice istituto di provenirenza: ");
     scanf("%d",&s->codiceprovenienza);
     printf("Inserisci la fascia di eta'(0=6-7 anni, 1=8-10 anni, 2=11-14 anni, 3=15-16 anni): ");
     scanf("%d",&s->fasciaeta);
}    

void ins_iscritto(struct atomo **TL, struct iscritto s)
{
      struct atomo *aux;
             
      aux=malloc(sizeof(struct atomo));
      if(aux==NULL) return;
      
      aux->dato=s;
      aux->next=*TL;
      *TL=aux;
}                   

void vis_iscritto(struct atomo *TL[4])
  {
        	int fascia,codiceprovenienza;
        	struct atomo *aux;
        
          	printf("Inserisci il codice dell'istituto ");
        	scanf("%d",&codiceprovenienza);
        
            for(fascia=0;fascia<4;fascia++)
            {       
             aux=TL[fascia];
        	 while(aux!=NULL)
        		{	if(aux->dato.codiceprovenienza == codiceprovenienza)
                    { printf("Nominativo %s\n",aux->dato.nominativo);
        			  printf("Codice identificativo: %d\n",aux->dato.codiceidentificativo);
        			  printf("Fascia eta': %d\n\n",aux->dato.fasciaeta);
                    }
                    aux=aux->next;
        		}
           }
}          
                                    
void leggi_attivita(struct attivita *a)
{    
     printf("Inserisci il codice identificativo iscritto: ");
     scanf("%d",&a->codiceiscritto);
     printf("Inserisci il codice animatore: ");
     scanf("%d",&a->codiceanimatore);
     printf("Inserisci il tipo di attivita' (0...3): ");
     scanf("%d",&a->tipoattivita);
}

void ins_ordinato(struct attivita *TP[4],int *N, struct attivita a)
{
        int i,k,ta;
        struct attivita *R;
               
        ta=a.tipoattivita;
        R=realloc(TP[ta],sizeof(struct attivita)*(N[ta]+1));
        if(R==NULL) return;
        TP[ta]=R;
        
        for(i=0;i<N[ta];i++)
         if(a.codiceiscritto<TP[ta][i].codiceiscritto)
             break;
                
        N[ta]++;
        for(k=N[ta]-1;k>i;k--)
            TP[ta][k]=TP[ta][k-1];
        TP[ta][i]=a;
}
                
void vis_attivita(struct attivita *TP[4], int *N)
{
     int tipoattivita,j;
     printf("Inserisci il tipo di attivita'(0..3):\n ");
     scanf("%d",&tipoattivita);
     
       for(j=0;j<N[tipoattivita];j++)
       {
           printf("Codice identificativo iscritto:%d\n",TP[tipoattivita][j].codiceiscritto);
           printf("Codice animatore:%d\n\n",TP[tipoattivita][j].codiceanimatore);
         
       }
}

void salva(struct attivita *TP[4], int *N)
 {
    	FILE *pf;
    	int i;
    	pf=fopen("attivita.dat","wb");
    	if(pf!=NULL)
    		{ for(i=0;i<4;i++)
    	         fwrite(TP[i],sizeof(struct attivita),N[i],pf);
    		  fclose(pf);
    	}
    	else printf("Errore in scrittura\n");
    }


void libera_liste(struct atomo **TL)
   {
        	struct atomo *aux;
        	while(*TL!=NULL)
        		{	aux=*TL;
        			*TL=aux->next;
        			free(aux);
        		}
        }

void iniz_tab(struct attivita *TP[4], int *N)
{
     int tipoattivita;
     struct attivita d, *a;
     FILE *pf;
     
     pf=fopen("attivita.dat","r");
     if(pf!=NULL)
     { while(fread(&d,sizeof(struct attivita),1,pf))
       {
         tipoattivita=d.tipoattivita;
         a=realloc(TP[tipoattivita],sizeof(struct attivita)*(N[tipoattivita]+1));
         if(a==NULL)break;
                                           
         TP[tipoattivita]=a;
         TP[tipoattivita][N[tipoattivita]]=d;
         N[tipoattivita]++;
       }                      
       fclose(pf);
     }
     else printf("\n\nInizializzazione senza successo. File inesistente!!\n");
}
                      

                              
                              
                
                              
